% Generates the Hinf MIMO and Hinf SISO controllers
%
%% Bandwidth
M=1.2;
wb=70*2*pi;
A=1e-4;
Wp=tf([1/M wb], [1 wb*A]);
Wu=0;
Wu=tf([1/1.2 0], [1 wb]);

%Find H-inf controller
[K,ghinf,GAM] = mixsyn(G_nodelay,Wp,Wu,W_O);

[K_SISO11,ghinf,GAM] = mixsyn(G_nodelay(1,1),Wp,Wu,W_O);
[K_SISO22,ghinf,GAM] = mixsyn(G_nodelay(2,2),Wp,Wu,W_O);

K_SISO = [K_SISO11, 0; 0, K_SISO22];

L = G*K;
T = (eye(2) + L)\L;
S = eye(2) - T;

L_SISO = G*K_SISO;
T_SISO = (eye(2) + L_SISO)\L_SISO;
S_SISO = eye(2) - T_SISO;

h=figure(9);
hb=sigmaplot(S,T);
setoptions(hb,'FreqUnits','Hz');
legend1 = legend('S','T','Location','SouthWest');
title('H-inf MIMO');
xlim([1,1e5]);
ylim([-50,10]);
grid on

export_plot('experiment_03_MIMO_h_inf_MIMO_sensitivity.pdf');

hb=sigmaplot(S_SISO,T_SISO);
setoptions(hb,'FreqUnits','Hz');
legend1 = legend('S','T','Location','SouthWest');
title('H-inf SISO');
xlim([1,1e5]);
ylim([-50,10]);
grid on

export_plot('experiment_03_MIMO_h_inf_SISO_sensitivity.pdf');


norm(pade(W_O*T_PID,5),Inf)
norm(pade(W_O*T_SISO,5),Inf)
norm(pade(W_O*T,5),Inf)


