%% Generates PID controller


K_PID_xx = pid( -5e-3, -370, -2.2e-05, Dt_step );
K_PID_yy = pid( -5e-3, -450, -2.2e-05, Dt_step );

K_PID = [ K_PID_xx, 0; 0, K_PID_yy ];

L_PID = G*K_PID;
T_PID = (eye(2) + L_PID)\L_PID;
S_PID = eye(2) - T_PID;
h=figure(9);


hb=sigmaplot(S_PID,T_PID);
setoptions(hb,'FreqUnits','Hz');
legend1 = legend('S','T','Location','SouthWest');
title('PID controller');
xlim([1,1e5]);
grid on

export_plot('experiment_03_MIMO_PID_sensitivity.pdf');

