%% Uses the experimental data and nominal plant G to find an appropriate uncertainty weighting W

h=figure(9);


%% Experimental data

load('data/01 - Plant Response G_hat/Run 1/GXX.MAT');
load('data/01 - Plant Response G_hat/Run 1/GXY.MAT');
load('data/01 - Plant Response G_hat/Run 1/GYX.MAT');
load('data/01 - Plant Response G_hat/Run 1/GYY.MAT');
freq_range = 5:397;
f = gxx(freq_range,1);
d = zeros(2,2,size(f,1));

d(1,1,:) =  gxx(freq_range,2);
d(1,2,:) =  gxy(freq_range,2);
d(2,1,:) =  gyx(freq_range,2);
d(2,2,:) =  gyy(freq_range,2);



G_experimental = frd(d,f,'FrequencyUnit','Hz');

bode(G, G_experimental)


%% Load other runs

load('data/01 - Plant Response G_hat/Run 2/GXX.MAT');
load('data/01 - Plant Response G_hat/Run 2/GXY.MAT');
load('data/01 - Plant Response G_hat/Run 2/GYX.MAT');
load('data/01 - Plant Response G_hat/Run 2/GYY.MAT');
freq_range = 5:397;
f = gxx(freq_range,1);
d = zeros(2,2,size(f,1));
d(1,1,:) =  gxx(freq_range,2);
d(1,2,:) =  gxy(freq_range,2);
d(2,1,:) =  gyx(freq_range,2);
d(2,2,:) =  gyy(freq_range,2);
G_experimental2 = frd(d,f,'FrequencyUnit','Hz');

load('data/01 - Plant Response G_hat/Run 3/GXX.MAT');
load('data/01 - Plant Response G_hat/Run 3/GXY.MAT');
load('data/01 - Plant Response G_hat/Run 3/GYX.MAT');
load('data/01 - Plant Response G_hat/Run 3/GYY.MAT');
freq_range = 5:397;
f = gxx(freq_range,1);
d = zeros(2,2,size(f,1));
d(1,1,:) =  gxx(freq_range,2);
d(1,2,:) =  gxy(freq_range,2);
d(2,1,:) =  gyx(freq_range,2);
d(2,2,:) =  gyy(freq_range,2);
G_experimental3 = frd(d,f,'FrequencyUnit','Hz');

bodeplot(G_experimental,G_experimental2,G_experimental3);

%%

[sv1,w] = sigma( (G_experimental - G_nodelay)/G_nodelay ); 
[sv2,w] = sigma( (G_experimental2 - G_nodelay)/G_nodelay ); 
[sv3,w] = sigma( (G_experimental3 - G_nodelay)/G_nodelay ); 

W_hat = max([sv1(1,:);sv2(1,:);sv3(1,:)]);

data = frd(W_hat,w);

W_O = zpk( {[-210;-1850];}, {[-2400;-3200;]}, [0.00203127357026773*6200/4*1.35*.9;] );

bp = sigmaplot(data,W_O);
setoptions(bp,'FreqUnits','Hz');
legend1 = legend('$\hat{W}$', '$W$','Location','NorthWest');
set(legend1,'Interpreter','latex');
ylabel('Gain');
title('');
grid on


export_plot('experiment_03_MIMO_W_O.pdf');



